#ifndef __tetris_h
#define __tetris_h

#include "music.h"

#define WIPESPEED 50

#define MAXLEVEL  13	/* At maxlevel, the blocks drop without any delay */

/* All the states here must be negative, except S_GAME,      *
 * which is 0. Also, S_MBLOCK must be S_INIT+1 and S_GAME-1. */
 
#define S_MIN    -100	/* Just a marker           */

#define S_PAUSE  -5		/* Pause                   */
#define S_DROP   -4		/* Dropping block          */
#define S_OVER   -3		/* Game over               */
#define S_INIT   -2		/* Just started            */
#define S_MBLOCK -1		/* Need to make new block  */
#define S_GAME    0		/* A block is falling down */

/* Todo: Check this. It may be incorrect. */
#define S_WIPE (24*MAINRATE/WIPESPEED S_MIN)

typedef int tetblock[4][4];
typedef struct
{
	int Field[18][10];
	
	int WipeLines[18];
	int WipeCount;
	
	int Score;
	int Lines;
	int Level;
	
	int NextColor;
	tetblock NextBlock;
	
	int ThisColor;
	tetblock ThisBlock;
	
	int asento, blnum, nextblnum;
	int blockx, blocky;
	
	int State, SavedState;
	int NeedRefresh;
	
	int dispx,dispy,nextx,statx;
	
	int iscomputer;
	
	struct MusicSave gameovermusicsave;
} tetris_t;

extern void InitTetris(tetris_t *tet,
	int lev,int hc,
	int x,int y,
	int nx,int sx,
	int iscomputer);
extern void KillTetris(tetris_t *tet);
extern void TickTetris(tetris_t *tet, int numticks);

/* Key values for GrantKey() - value 0 not allowed. */
#define KEY_LT		1
#define KEY_RT		2
#define KEY_DOWN	3
#define KEY_TURN1	4
#define KEY_TURN2	5
#define KEY_DROP	6
#define KEY_PAUSE	7

/* Control */
extern void GrantKey(tetris_t *tet, int key);

#endif	/* __tetris_h defined */
